// this is a subset of 'control.h' (DX SDK)
// if you have the working original iclude it instead of this

typedef double REFTIME;
typedef LONG_PTR OAEVENT;
typedef LONG_PTR OAHWND;
typedef long OAFilterState;

typedef interface IMediaControl IMediaControl;
typedef interface IMediaEventEx IMediaEventEx;
typedef interface IMediaPosition IMediaPosition;
typedef interface IVideoWindow IVideoWindow;

DEFINE_GUID(IID_IMediaControl,0x56a868b1,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
typedef struct IMediaControlVtbl {
	BEGIN_INTERFACE

	HRESULT (STDMETHODCALLTYPE *QueryInterface) (IMediaControl * This,REFIID riid,void **ppvObject);

	ULONG dummy01;	// this pointer is not used

	ULONG (STDMETHODCALLTYPE *Release) (IMediaControl * This);

	HRESULT dummy02;	// also not used..
	HRESULT dummy03;
	HRESULT dummy04;
	HRESULT dummy05;

	HRESULT (STDMETHODCALLTYPE *Run) (IMediaControl * This);
	HRESULT (STDMETHODCALLTYPE *Pause) (IMediaControl * This);
	HRESULT (STDMETHODCALLTYPE *Stop) (IMediaControl * This);

	HRESULT dummy06;
	HRESULT dummy07;
	HRESULT dummy08;
	HRESULT dummy09;
	HRESULT dummy10;
	HRESULT dummy11;

	END_INTERFACE
}
IMediaControlVtbl;

interface IMediaControl {
	CONST_VTBL struct IMediaControlVtbl *lpVtbl;
};


DEFINE_GUID(IID_IMediaEventEx,0x56a868c0,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
typedef struct IMediaEventExVtbl {
	BEGIN_INTERFACE

	HRESULT ( STDMETHODCALLTYPE *QueryInterface )(
		IMediaEventEx * This,
		/* [in] */ REFIID riid,
		/* [iid_is][out] */ void **ppvObject);

	ULONG dummy01;	// this pointer is not used

	ULONG (STDMETHODCALLTYPE *Release) (IMediaEventEx * This);

	HRESULT dummy02;	// also not used..
	HRESULT dummy03;
	HRESULT dummy04;
	HRESULT dummy05;
	HRESULT dummy06;

	HRESULT ( STDMETHODCALLTYPE *GetEvent )(
		IMediaEventEx * This,
		/* [out] */ long *lEventCode,
		/* [out] */ LONG_PTR *lParam1,
		/* [out] */ LONG_PTR *lParam2,
		/* [in] */ long msTimeout);

	HRESULT dummy07;
	HRESULT dummy08;
	HRESULT dummy09;

	HRESULT ( STDMETHODCALLTYPE *FreeEventParams )(
		IMediaEventEx * This,
		/* [in] */ long lEvCode,
		/* [in] */ LONG_PTR lParam1,
		/* [in] */ LONG_PTR lParam2);

	HRESULT ( STDMETHODCALLTYPE *SetNotifyWindow)(
		IMediaEventEx * This,
		/* [in] */ OAHWND hwnd,
		/* [in] */ long lMsg,
		/* [in] */ LONG_PTR lInstanceData);

	HRESULT ( STDMETHODCALLTYPE *SetNotifyFlags )(
		IMediaEventEx * This,
		/* [in] */ long lNoNotifyFlags);

	HRESULT dummy10;

	END_INTERFACE
}
IMediaEventExVtbl;

interface IMediaEventEx {
	CONST_VTBL struct IMediaEventExVtbl *lpVtbl;
};


DEFINE_GUID(IID_IMediaPosition,0x56a868b2,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
typedef struct IMediaPositionVtbl {
	BEGIN_INTERFACE

	HRESULT (STDMETHODCALLTYPE *QueryInterface) (IMediaPosition * This,REFIID riid,void **ppvObject);

	ULONG dummy01;	// this pointer is not used

	ULONG (STDMETHODCALLTYPE *Release) (IMediaPosition * This);

	HRESULT dummy02;	// also not used..
	HRESULT dummy03;
	HRESULT dummy04;
	HRESULT dummy05;
	HRESULT dummy06;

	HRESULT (STDMETHODCALLTYPE *put_CurrentPosition) (IMediaPosition * This,REFTIME llTime);

	HRESULT dummy07;	// also not used..
	HRESULT dummy08;
	HRESULT dummy09;
	HRESULT dummy10;
	HRESULT dummy11;
	HRESULT dummy12;
	HRESULT dummy13;
	HRESULT dummy14;
	HRESULT dummy15;

	END_INTERFACE
}
IMediaPositionVtbl;

interface IMediaPosition {
	CONST_VTBL struct IMediaPositionVtbl *lpVtbl;
};



DEFINE_GUID(IID_IVideoWindow,0x56a868b4,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
typedef struct IVideoWindowVtbl {
	BEGIN_INTERFACE

	HRESULT (STDMETHODCALLTYPE *QueryInterface) (IVideoWindow * This,REFIID riid,void **ppvObject);

	ULONG dummy01;	// this pointer is not used

	ULONG (STDMETHODCALLTYPE *Release) (IVideoWindow * This);

	HRESULT dummy02;	// also not used..
	HRESULT dummy03;
	HRESULT dummy04;
	HRESULT dummy05;
	HRESULT dummy06;
	HRESULT dummy07;

	HRESULT (STDMETHODCALLTYPE *put_WindowStyle) (IVideoWindow * This,long WindowStyle);

	HRESULT dummy08;
	HRESULT dummy09;
	HRESULT dummy10;
	HRESULT dummy11;
	HRESULT dummy12;
	HRESULT dummy13;
	HRESULT dummy14;
	HRESULT dummy15;
	HRESULT dummy16;

	HRESULT (STDMETHODCALLTYPE *put_Visible ) (IVideoWindow * This,long Visible);

	HRESULT dummy17;
	HRESULT dummy18;
	HRESULT dummy19;
	HRESULT dummy20;
	HRESULT dummy21;
	HRESULT dummy22;
	HRESULT dummy23;
	HRESULT dummy24;
	HRESULT dummy25;

	HRESULT (STDMETHODCALLTYPE *put_Owner) (IVideoWindow * This,OAHWND Owner);

	HRESULT dummy26;
	HRESULT dummy27;
	HRESULT dummy28;
	HRESULT dummy29;
	HRESULT dummy30;
	HRESULT dummy31;
	HRESULT dummy32;
	HRESULT dummy33;
	HRESULT dummy34;

	HRESULT (STDMETHODCALLTYPE *SetWindowPosition) (IVideoWindow * This,long Left,long Top,long Width,long Height);

	HRESULT dummy35;
	HRESULT dummy36;
	HRESULT dummy37;
	HRESULT dummy38;
	HRESULT dummy39;
	HRESULT dummy40;

	END_INTERFACE
}
IVideoWindowVtbl;

interface IVideoWindow {
	CONST_VTBL struct IVideoWindowVtbl *lpVtbl;
};

