// DShow Tutorial Part 2 for LCC WIN32 Total Conversion for LCC32 by gash
// based on DShowTut2 located at 'http://www.flipcode.com/
// A MUST READ FOR DSHOW BEGINNER
//
// It's a example howto 'DSHOW' in LCC32 and i have renamed it to 'RenderIt'
// As the name says- it does GraphRendering of ANY (nearly) MediaFile
// Just FireUp and open the mediafile of your choice..
// It provides all the simple functions as Play, Stop, Loop
// and as a addition it makes a 'graph.log' from what GraphBuilder is
// doing with your file. It makes an entry in the running object table
// so in GraphEdit you can 'Connect'
// It is far from perfect but i think a good starting point to
// DSHOW coding in LCC32	- in short  a '8K Mediaplayer'
//
// It uses Jacobs NEW simple interface 'object->Method(arguments)'
// and doesnt come with 1000ths of includes and libs
// Just include 'ole32.lib' (here done by '#pragma lib <ole32.lib>')
//

// For serious coding You need at least 'uuids.h', 'control.h', 'strmif.h'  from DX SDK
// then and only then you can make more out of it.
// If you don't have the WORKING originals use my subsets
//
// And Now tell me why it doesnt handle GRF files ?


#include <windows.h>
#include "resource.h"
/*<---------------------------------------------------------------------->*/
#include <objbase.h>			// first this
#include <initguid.h>			// and then this !
#pragma lib <ole32.lib>			// the only needed lib - COM needs it

/*<---------------------------------------------------------------------->*/
// here are the DirectShow definition files and my alt. subsets
// NOTE: this subsets are only for this example - you can't do anything else with it
//
//#include <dx8\uuids.h>		// include if you have a working 'uuids.h'
#include "uuids_subset.h"		// or take this MINIMAL subset
//#include <dx8\control.h>		// include if you have a working 'control.h'
#include "control_subset.h"		// or take this MINIMAL subset
//#include <dx8\strmif.h>		// include if you have a working 'strmif.h'
#include "strmif_subset.h"		// or take this MINIMAL subset
/*<---------------------------------------------------------------------->*/


// let the show begin

// get rid of <windowsx.h>
#define	HANDLE_WM_COMMAND(hwnd,wParam,lParam,fn)((fn)((hwnd),(int)(LOWORD(wParam)),(HWND)(lParam),(UINT)HIWORD(wParam)),0L)

#define EC_COMPLETE 0x01
#define WM_GRAPHEVENT WM_USER		// define a custom window message for graph events
#define OAFALSE (0)

// convenient macro for releasing interfaces (NICE ONE)
#define HELPER_RELEASE(x) if(x) {x->Release();x=NULL;};


// DirectShow interfaces
IGraphBuilder*	g_pGraphBuilder = NULL;
IMediaControl*	g_pMediaControl = NULL;
IMediaEventEx*	g_pMediaEventEx = NULL;
IMediaPosition*	g_pMediaPosition = NULL;
IVideoWindow*   pVidWin = NULL;

//IStorage* pStorage = NULL;

IMoniker *moniker;
IRunningObjectTable *rot;
BOOL rot_ok = FALSE;
DWORD register_id;

HINSTANCE hInst;	// Instance handle
HWND hwndMain;		//Main window handle

BOOL g_Looping = FALSE;          // should we loop the media

char g_ExecuteDir[MAX_PATH];     // directory of execution
char g_WindowTitle[] = "DShowTut2";	// text for title bar

// the one and only forward declaration
LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);


int InitDirectShow() {
	HRESULT hr;
	hr = CoCreateInstance(&CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER,
		&IID_IGraphBuilder, (void**)&g_pGraphBuilder);

	if (FAILED(hr)) return -1;
	g_pGraphBuilder->QueryInterface(&IID_IMediaControl, (void**)&g_pMediaControl);
	g_pGraphBuilder->QueryInterface(&IID_IMediaEventEx, (void**)&g_pMediaEventEx);
	g_pGraphBuilder->QueryInterface(&IID_IMediaPosition, (void**)&g_pMediaPosition);
	g_pGraphBuilder->QueryInterface(&IID_IVideoWindow, (void **)&pVidWin);
	g_pMediaEventEx->SetNotifyWindow((OAHWND)hwndMain, WM_GRAPHEVENT, 0);
	g_pMediaEventEx->SetNotifyFlags(0);	// turn on notifications
	return 0;
};


void CleanUpDirectShow() {
	if (rot_ok && SUCCEEDED(GetRunningObjectTable(0, &rot)))
	{
		rot->Revoke(register_id);
		rot->Release();
	}
	if (pVidWin) pVidWin->put_Visible(OAFALSE);
	if (pVidWin) pVidWin->put_Owner((OAHWND) NULL);

	HELPER_RELEASE(pVidWin);
	HELPER_RELEASE(g_pMediaPosition);
	HELPER_RELEASE(g_pMediaEventEx);
	HELPER_RELEASE(g_pMediaControl);
	HELPER_RELEASE(g_pGraphBuilder);
};


int CreateGraph(char* filename) {
	int length;		// length of filename
	WORD wfilename[MAX_PATH];

	HRESULT hr;
	HANDLE  logfile;                  // log file for graphbuilder
	char    logfilename[MAX_PATH];    // full path and name of log file

	// create graphbuilder's log file;  we must give it a full path or
	// else it will create the log file in the directory the media file is
	// located in
	wsprintf(logfilename, "%s\\graph.log", g_ExecuteDir);
	logfile = CreateFile(logfilename, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL, NULL);

	g_pGraphBuilder->SetLogFile((DWORD_PTR) logfile);

	// attempt to build a graph
	length = strlen(filename)+1;

	MultiByteToWideChar(CP_ACP, 0, filename, -1, wfilename, length);

	hr = g_pGraphBuilder->RenderFile(wfilename, NULL);

	CloseHandle(logfile);



	if (FAILED(hr))	return hr;
	else rot_ok=FALSE;

	if (FAILED(GetRunningObjectTable(0, &rot))) return -1;

	WCHAR str[256];
	wsprintfW(str, L"FilterGraph %08x pid %08x", (DWORD_PTR)g_pGraphBuilder,GetCurrentProcessId());

	if SUCCEEDED(CreateItemMoniker(L"!", str, &moniker)) {
		if SUCCEEDED(rot->Register(0, (IUnknown *)g_pGraphBuilder, moniker, &register_id))
			rot_ok = TRUE;
		moniker->Release();
		return 0;
	}
	rot->Release();

	return -1;
};


// called when directshow events occur
void OnGraphEvent() {
	long EventCode, Param1, Param2;
	while (g_pMediaEventEx->GetEvent(&EventCode, &Param1, &Param2, 0) != E_ABORT) {

		switch (EventCode) {

		case EC_COMPLETE:
			// here when media is completely done playing
			if (!g_Looping)	g_pMediaControl->Stop();
			g_pMediaPosition->put_CurrentPosition(0);   // reset to beginning
			break;

		default:
			break;
		}

		g_pMediaEventEx->FreeEventParams(EventCode, Param1, Param2);
	}
};


BOOL InitApplication(void) {
	WNDCLASS wc;

	CoInitialize(NULL);

	memset(&wc,0,sizeof(WNDCLASS));
	wc.style = CS_HREDRAW|CS_VREDRAW |CS_DBLCLKS ;
	wc.lpfnWndProc = (WNDPROC)MainWndProc;
	wc.hInstance = hInst;
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszClassName = "renderitWndClass";
	wc.lpszMenuName = MAKEINTRESOURCE(IDMAINMENU);
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);
	if (!RegisterClass(&wc)) return 0;
	return 1;
};


HWND CreaterenderitWndClassWnd(void) {
	return CreateWindow("renderitWndClass","renderit",
		WS_MINIMIZEBOX|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN|
		    WS_MAXIMIZEBOX|WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_THICKFRAME,
		CW_USEDEFAULT,0,CW_USEDEFAULT,0,
		NULL,
		NULL,
		hInst,
		NULL);

};


void MainWndProc_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify) {
	char buffer[MAX_PATH];

	switch(id) {

	case ID_FILE_OPEN:
		{
			OPENFILENAME    ofn;    // use common 'Open' control
			char file[MAX_PATH];     // filename with path
			char filetitle[MAX_PATH];    // thrown in to show file in title bar

			memset(file, 0, MAX_PATH);
			memset(&ofn, 0, sizeof(OPENFILENAME));
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = NULL;
			ofn.lpstrFile = file;
			ofn.nMaxFile = MAX_PATH-1;
			ofn.lpstrFileTitle = filetitle;
			ofn.nMaxFileTitle = MAX_PATH-1;
			ofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;

			if (GetOpenFileName(&ofn)) {

				CleanUpDirectShow();    // release previous graph
				if (InitDirectShow() != 0) MessageBox(NULL, "Could not initialize DirectShow!", "ERROR", MB_OK);
				else {

					int errorcode;
					errorcode=CreateGraph(file);

					if (errorcode !=0) {
						char    ErrorText[20];
						wsprintf(ErrorText, "ERROR - 0x%X", errorcode);
						MessageBox(NULL, "Could not create a filter graph for this file!",ErrorText, MB_OK);
					}
					else {
						//Set the video window.
						pVidWin->put_Owner((OAHWND)hwndMain);
						pVidWin->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS);

						RECT grc;
						GetClientRect(hwndMain, &grc);
						pVidWin->SetWindowPosition(0, 0, grc.right, grc.bottom);

						char    NewTitle[256];
						wsprintf(NewTitle, "%s - %s", g_WindowTitle, filetitle);
						SetWindowText(hwndMain, NewTitle);

						// immediate Run after Loading
						if (g_pMediaControl) g_pMediaControl->Run();
					}
				}
			}
			break;
		}

	case ID_FILE_EXIT:
		CleanUpDirectShow();    // release previous graph
		PostQuitMessage(0);
		break;

	case ID_MEDIA_PLAY:
		if (g_pMediaControl) g_pMediaControl->Run();
		else MessageBox(NULL, "Select a file to play first!", g_WindowTitle, MB_OK);
		break;

	case ID_MEDIA_STOP:
		if (g_pMediaPosition) {
			g_pMediaControl->Stop();
			g_pMediaPosition->put_CurrentPosition(0);   // return to beginning
		}
		break;

	case ID_OPTIONS_LOOPING:
		if (g_Looping) {
			CheckMenuItem(GetMenu(hwndMain), ID_OPTIONS_LOOPING, MF_BYCOMMAND | MF_UNCHECKED);
			g_Looping = FALSE;
		}
		else {
			CheckMenuItem(GetMenu(hwndMain), ID_OPTIONS_LOOPING, MF_BYCOMMAND | MF_CHECKED);
			g_Looping = TRUE;
		}
		break;

	case IDM_EXIT:
		PostMessage(hwnd,WM_CLOSE,0,0);
		break;

	case IDM_ABOUT:
		MessageBox(NULL, "DShowTutorial for LCC32 based on http://www.flipcode.com","RenderIt", MB_OK);
		break;
	}
};


LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam) {
	switch (msg) {

	case WM_GRAPHEVENT:
		OnGraphEvent();		// handles events
		break;

	case WM_SIZE:
		{
			RECT grc;
			GetClientRect(hwndMain, &grc);
			if (pVidWin) pVidWin->SetWindowPosition(0, 0, grc.right, grc.bottom);
			break;
		}

	case WM_COMMAND:
		HANDLE_WM_COMMAND(hwnd,wParam,lParam,MainWndProc_OnCommand);
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
	}
	return 0;
};


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow) {
	MSG msg;
	HANDLE hAccelTable;

	hInst = hInstance;
	if (!InitApplication())	return 0;

	hAccelTable = LoadAccelerators(hInst,MAKEINTRESOURCE(IDACCEL));
	if ((hwndMain = CreaterenderitWndClassWnd()) == (HWND)0) return 0;

	ShowWindow(hwndMain,SW_SHOW);
	GetCurrentDirectory(MAX_PATH, g_ExecuteDir);

	while (GetMessage(&msg,NULL,0,0)) {
		if (!TranslateAccelerator(msg.hwnd,hAccelTable,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	CleanUpDirectShow();

	CoUninitialize();
	return msg.wParam;
}
